QCAT - Task #1782
User Story # 1781 (Closed): Versioning of configuration

Proof of concept: new configuration as code
06 Feb 2018 14:24 - Sebastian Manger

Status: Closed Start date: 06 Feb 2018
Priority: High Due date:

Assignee: % Done: 0%
Category: Estimated time: 80.00 hours
Target version: Carbon Benefit Spent time: 80.00 hours
Resolution:

Description

Notes

e Similar to a django migration
¢ Specify diff only, as code

Change fields

Add fields

Delete fields

Change field order

Change section of question

¢ Set documentation/"What's new" in diff
e Make 'context aware' change hints for questions possible
e Use new table (or existing configuration table) to store the documentation/"What's new" and changed fields

Estimate breakdown

e Extend/create table for documentation/"what's new": 2h
¢ New command to load data from diff (base class)

¢ Validate ' version history' (depends_on): 4h

e Set structure for command content: changes, documentation, help text: 2h
¢ Add new field: (8h)

¢ Change order: question, questiongroup, section: (8h)

¢ Change structure (move question between sections): (8h)
¢ Change field type: (8h)

¢ Delete field: (8h)

* Merge data with previous version and get json: 8h

e Validate structure: 2h

e Save to db: 2h

¢ Internal review (ongoing): 8h

e Tests: 12h

History

#1 - 06 Feb 2018 16:46 - Lukas Vonlanthen
- Description updated

#2 - 06 Feb 2018 18:10 - Sebastian Manger
- Description updated

#3 - 08 Feb 2018 11:20 - Lukas Vonlanthen
- translation missing: en.field_tag_list set to Required

- Description updated
- Estimated time set to 80.00 h

#4 - 27 Feb 2018 09:52 - Kurt Gerber

- Status changed from New to Accepted

#5 - 27 Feb 2018 09:54 - Kurt Gerber
- Priority changed from Normal to High

#6 - 19 Mar 2018 16:05 - Sebastian Manger
Next steps (blocker, pair programming recommended)
e decisions: naming
¢ migrate configuration (and questionnaire) model
* data migration for existing configuration / questionnaires --> this will break things!

'single' tasks:

e (abstract) base class for new releases
¢ basic code cleanup: split 'name' of configuration and 'version' (‘technologies' -> 'technologies_2016')

#7 - 05 Apr 2018 09:41 - Kurt Gerber

- Status changed from Accepted to In Progress

#8 - 04 Jul 2018 10:02 - Lukas Vonlanthen

- Status changed from In Progress to Closed
